
package Nexus::RPCStatus;

#$OVERLOAD{'""'} = 'as_string';
#$OVERLOAD{fallback} = 1;

sub new
{
    my($class, $rref, $name, $rpc_argref) = @_;
    my($self);

    $self = { rref => $rref,
	      name => $name,
	      finished => 0,
	      argref => $rpc_argref,
	      };

    bless($self, $class);
    return $self;
}

sub as_string
{
    my($self) = @_;
    return "RPCStatus($self->{name} $self->{rref})";
}

sub register_callback
{
    my($self, $cb) = @_;
    
    $self->{finished_callback} = $cb;
    if ($self->{finished})
    {
	&$cb($self);
    }
}

sub set_return_value
{
    my($self, $ret) = @_;
    my($cb);
    
    print "Nexus::RPCStatus(): $self set return value\n" if $debug;
    $self->{return_value} = $ret;
    $self->{finished} = 1;
    if (defined($cb = $self->{finished_callback}))
    {
	&$cb($self);
    }
}

sub return_value
{
    my($self) = @_;
    return $self->{return_value};
}

sub finished
{
    my($self) = @_;
    return $self->{finished};
}

sub DESTROY
{
    my($self) = @_;
#    print "****** Nexus::RPCStatus::DESTROY: $self $self->{name} $self->{rpc_argref}\n";
}

1;
