#include "EXTERN.h"
#include "perl.h"
#include "nexus.h"
#include "pnx.h"

void pnx_fault_boot()
{
}



static int fault_callback(void *arg, int fault_code)
{
    int rc, count;
    SV *cb_func;
    SV *fault_string;
    dSP;

    cb_func = (SV *) arg;
    
    fault_string = newSViv(fault_code);
    sv_setpv(fault_string, nexus_fault_strings[fault_code]);
    SvIOK_on(fault_string);

    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(fault_string));
    PUTBACK ;
    
    count = perl_call_sv(cb_func, G_EVAL | G_SCALAR);
    
    SPAGAIN ;
    if (count != 1)
	croak("perl_call_sv shoulda returned one");
    
    rc = POPi;
    
    PUTBACK ;
    FREETMPS ;
    LEAVE ;

    return rc;
}

void pnx_enable_fault_tolerance(SV *func)
{

    /*
     * If undef is passed in, treat it as if NULL were passed to the
     * Nexus call.
     */
    if (!SvOK(func))
    {
	nexus_enable_fault_tolerance(NULL, NULL);
    }
    else
    {
	SvREFCNT_inc(func);
	nexus_enable_fault_tolerance(fault_callback, (void *) func);
    }

}
